#ifndef DBINTERFACE_HH
#define DBINTERFACE_HH
#include "art/Framework/Services/Registry/ServiceMacros.h"
#include "darksidecore/ArtServices/ds50db_interface.hh"

namespace art {
  class ActivityRegistry;
  class Run;
}

namespace fhicl {
  class ParameterSet;
}

namespace ds50 {
  class DBInterface: public db::interface {
    public:
      DBInterface (const fhicl::ParameterSet&, art::ActivityRegistry&);
      void pre_begin_run (const art::Run& run);
      void post_begin_run (const art::Run& run);
      void pre_end_run (const art::RunID& run, const art::Timestamp& ts);
  };
}


DECLARE_ART_SERVICE(ds50::DBInterface, LEGACY)
#endif
