////////////////////////////////////////////////////////////////////////
// Class:       CheckSim
// Module Type: analyzer
// File:        CheckSim_module.cc
//
// Generated at Wed Mar 20 12:05:17 2013 by Marc Paterno using artmod
// from art v1_03_08.
////////////////////////////////////////////////////////////////////////

#include "art/Framework/Core/EDAnalyzer.h"
#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Handle.h"
#include "art/Framework/Principal/Run.h"
#include "art/Framework/Principal/SubRun.h"
#include "art/Framework/Services/Optional/TFileService.h"
#include "cpp0x/memory"
#include "fhiclcpp/ParameterSet.h"

#include "TH1F.h"

#include "artdaq-core/Data/Fragments.hh"
#include "darksidecore/Data/V172xFragment.hh"

using ds50::V172xFragment;

class CheckSim;

class CheckSim : public art::EDAnalyzer {
public:
  explicit CheckSim(fhicl::ParameterSet const & p);
  virtual ~CheckSim();

  void analyze(art::Event const & e) override;

  void beginJob() override;

private:
  TH1F* v1720_counts_;
  TH1F* v1724_counts_;
};


CheckSim::CheckSim(fhicl::ParameterSet const &p) :
  art::EDAnalyzer(p),
  v1720_counts_(),
  v1724_counts_()
{
}

CheckSim::~CheckSim()
{
  // We don't own Root's histograms, so don't delete them!
}

void CheckSim::analyze(art::Event const & e)
{
  art::Handle<artdaq::Fragments> h_v1724;
  e.getByLabel("daq", "V1724", h_v1724);
  artdaq::Fragments const& v1724 = *h_v1724;


  for (auto const& frag : v1724)
    {
      ds50::V172xFragment overlay(frag);
      for (auto i = overlay.dataBegin(), e = overlay.dataEnd(); i != e; ++i)
        {
          v1724_counts_->Fill(*i);
        }
    }



}

void CheckSim::beginJob()
{
  art::ServiceHandle<art::TFileService> tfs;
  v1724_counts_ = tfs->make<TH1F>("v1724 counts", 
                                  "channel counts for v1724", 
                                  std::numeric_limits<V172xFragment::adc_type>::max()+1,
                                  -0.5, 
                                  std::numeric_limits<V172xFragment::adc_type>::max() + 0.5);
}

DEFINE_ART_MODULE(CheckSim)
