#include "art/Framework/Core/EDProducer.h"
#include "art/Framework/Core/ModuleMacros.h"
#include "art/Framework/Principal/Event.h"
#include "art/Framework/Principal/Selector.h"
#include "art/Framework/Principal/Handle.h"
#include "art/Framework/Principal/Run.h"
#include "art/Framework/Principal/SubRun.h"
#include "art/Persistency/Provenance/BranchType.h"
#include "art/Persistency/Provenance/EventID.h"
#include "darksidecore/Compression/Encoder.hh"
#include "darksidecore/Compression/Properties.hh"
#include "darksidecore/Compression/SymTable.hh"
#include "darksidecore/Data/V172xFragment.hh"
#include "darksidecore/Data/CompressedV172x.hh"
#include "artdaq-core/Data/Fragment.hh"
#include "artdaq-core/Data/Fragments.hh"
#include "cpp0x/memory"
#include "fhiclcpp/ParameterSet.h"
#include "messagefacility/MessageLogger/MessageLogger.h"

#include "artdaq/DAQrate/quiet_mpi.hh"

#include <iostream>
#include <list>
#include <ostream>
#include <fstream>
#include <string>
#include <utility>


/*
 */

namespace
{

}

namespace ds50 {

  class DS50HuffCalib : public art::EDProducer
  {
  public:
    explicit DS50HuffCalib(fhicl::ParameterSet const & p);
    virtual ~DS50HuffCalib() { }

    virtual void produce(art::Event & e);
    virtual void endSubRun(art::SubRun & sr);
    virtual void endRun(art::Run & r);

  private:
    std::string const raw_label_;
    std::string const inst_name_;
  };


  DS50HuffCalib::DS50HuffCalib(fhicl::ParameterSet const & p)
  : raw_label_(p.get<std::string>("raw_label","daq")),
    inst_name_(p.get<std::string>("instance_name")),
  {
    // produces<NothingRightNow>(inst_name_);
  }

  void DS50HuffCalib::produce(art::Event & e)
  {
    art::Handle<artdaq::Fragments> h_172x;
    e.getByLabel(raw_label_, inst_name_, h_172x);

    

    // h_172x->dataBegin(), h_172x->dataEnd()
    size_t const len = h_172x->size();

    for (size_t i = 0; i < len; ++i) 
      {
	artdaq::Fragment const & frag = (*h_172x)[i];
	V172xFragment b(frag);
	// start of payload is the DS50 header
	auto adc_start = b.dataBegin();
	auto adc_end   = b.dataEnd();
      }    
  }

  void DS50HuffCalib::endSubRun(art::SubRun &) { }

  void DS50HuffCalib::endRun(art::Run &) 
  {
  }

  DEFINE_ART_MODULE(DS50HuffCalib)
}

