#include "darksidecore/Data/V1495Fragment.hh"
#include "cetlib/exception.h"

namespace {
  unsigned int pop_count (ds50::V1495Fragment::trigger_pattern_t n) {
    unsigned int c;
    for (c = 0; n; c++) n &= n - 1;
    return c;
  }
}


bool ds50::V1495Fragment::channel_in_trigger (int ch) const {
  if (ch < 0 || ch > 39) throw cet::exception("V1495Fragment") << "illegal channel request " << ch;
  return (trigger_pattern () >> ch) & 1;
}

unsigned int ds50::V1495Fragment::trigger_multiplicity () const {
  return pop_count (trigger_pattern ());
}


std::ostream & ds50::operator << (std::ostream & os, V1495Fragment const & b) {
  os << "V1495 Fragment Run: "
    << b.run_number ()
    << ", event counter: "
    << b.trigger_counter ()
    << ", event type: "
    << static_cast<int>(b.trigger_type ())
    << ", trigger pattern "
    << b.trigger_pattern ()
    << ". event size: "
    << b.event_size ();

  return os;
}

